/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AddressbooksSynchronizer.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var gTempName;
var gUsesPopup;
var gStatusbar;

var gPrefService = Components.classes["@mozilla.org/preferences-service;1"].
  getService(Components.interfaces.nsIPrefService);
var pref = Components.classes["@mozilla.org/preferences-service;1"]
    .getService(Components.interfaces.nsIPrefBranch);
var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"]
    .getService(Components.interfaces.nsIRDFService);
var directory = rdf.GetResource("moz-abdirectory://")
    .QueryInterface(Components.interfaces.nsIAbDirectory);
var gDirectoryService = Components.classes['@mozilla.org/file/directory_service;1']
    .getService(Components.interfaces.nsIProperties);
var console = Components.classes["@mozilla.org/consoleservice;1"]
    .getService(Components.interfaces.nsIConsoleService);
var prompter = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
    .getService(Components.interfaces.nsIPromptService);


/*
 *  Read a mab file and return the data
 */
function readMabData(nsIMabFile, addLastMod)
{
  if (!nsIMabFile.exists()) return '';

  var fs = Components.classes['@mozilla.org/network/file-input-stream;1']
          .createInstance(Components.interfaces.nsIFileInputStream);
  var ss = Components.classes['@mozilla.org/scriptableinputstream;1']
          .createInstance(Components.interfaces.nsIScriptableInputStream);
  var str='';
  try{
    fs.init(nsIMabFile, 0x01, 0000, false);
    ss.init(fs);
    str = ss.read(-1);
    ss.close();
    fs.close();
  } catch(e){ alert('readMabData:\n'+e); }
//    return str;
  if (addLastMod) {
    var lmt=new Date(nsIMabFile.lastModifiedTime);
    return str.replace(/-->[^\r\n]*/,'--> '+lmt);//append to the // <!-- <mdb:mork:z v="1.4"/> -->
  } else
    return str;
}

/*
 *  Save Data to a mab File
 */
function writeMabData(nsIMabFile, abData)
{
  try {
    //if (nsIMabFile.exists() && nsIMabFile.isFile()) nsIMabFile.remove(false);
    var strm = Components.classes["@mozilla.org/network/file-output-stream;1"].
      createInstance(Components.interfaces.nsIFileOutputStream);
    strm.QueryInterface(Components.interfaces.nsIOutputStream);
    strm.QueryInterface(Components.interfaces.nsISeekableStream);
    strm.init( nsIMabFile, 0x20|0x02|0x08, 0600, 0 );
      // 0x02=PR_WRONLY, 0x08=PR_CREATE_FILE, 0x20=PR_TRUNCATE
    strm.write( abData, abData.length );
    strm.flush();
    strm.close();
  } catch(e) { alert('File write error of '+nsIMabFile.target+'\n'+e); return null;}
  return nsIMabFile;
}

/*
 *  copy a mab file to another location
 */
function saveMabFile(mabName, mabFile, directory, filename)
{
    var localMabFile = getDir('ProfD');
    localMabFile.appendRelativePath( mabFile );

    try {
      var file = Components.classes["@mozilla.org/file/local;1"].
        createInstance(Components.interfaces.nsILocalFile);
      file.initWithFile( directory );
      file.appendRelativePath( filename );
//TODO: eventuell umbenennen statt lschen
      if (file.exists() && file.isFile()) { file.remove(false); }
      localMabFile.copyTo( directory, filename );
        //creates directory, if not existing! retains lastModifiedTime !
    } catch(e) { return false; }
    return true;
} //

function remove_openstate() {
    //Work around a bug(?) when the localstore holds the open state on maillists
    // We remove it for all maillist, not only for the maillists of the current directory,
    // since its possible that an book is deleted by the addressbook window
    // and recreated with this routine. In this case we can't determine the affected lists

  //First, get the datasource and some resources
  var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].
          getService(Components.interfaces.nsIRDFService);
  var localstore = rdf.GetDataSource("rdf:local-store");
  var pred = rdf.GetResource("http://home.netscape.com/NC-rdf#open", true);
  var val=rdf.GetLiteral("true");
  localstore.beginUpdateBatch();
  var lists=localstore.GetSources (pred, val, true);
  while (lists.hasMoreElements()) {
    var list=lists.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
    if (list.Value.match(/^moz-abmdbdirectory:\/\/.*\/MailList\d+$/)) {
      localstore.Unassert(list, pred, val);
    }
  }
  localstore.endUpdateBatch();
}

function replaceAddressBook(mabName, mabFile, file) {
if (!mabFile) {
 var err='Internal error: empty filename for addressbook "'+mabName+'"';
 alert(err);
 return err;
}

  remove_openstate(); //Bug in TB2

  var ret;
  var syncpolicy = gAddressbooksSync.syncpolicy;
  var dir=gAddressbooksSync.getAddressBook(mabFile);
  if (!dir) { // must be via file!
    ret=replaceAddressBook_viaFile(mabName, mabFile, file);
  } else if (syncpolicy=='entry') {
/*
    //workaround for a very mysterious problem:
    // Maillists are not loaded if filename contains spaces!
    if (file.path.indexOf(' ')>=0) {
      var newFile=getDir('TmpD');
      gTempName='abstemp.mab';
      newFile.appendRelativePath(gTempName);
      if (newFile.exists() && newFile.isFile()) { newFile.remove(false); }
      file.copyTo( getDir('TmpD'), gTempName );
      file=newFile;
    }
*/
    ret=replaceAddressBook_viaEntry(mabName, mabFile, file);
  } else {
    var dirProp = gAddressbooksSync.noDirProp?dir:dir.directoryProperties;
    var uri=dirProp.URI;
    if (uri==kPersonalAddressbookURI || uri==kCollectedAddressbookURI) {
      ret=replaceAddressBook_viaEntry(mabName, mabFile, file);
    } else {
      ret=replaceAddressBook_viaFile(mabName, mabFile, file);
    }
  }
  return ret;
}

function replaceAddressBook_viaFile(mabName, mabFile, file)
{
  dir=gAddressbooksSync.getAddressBook(mabFile);
  var oldPrefName=null;
  if (dir) {
    var dirProp = gAddressbooksSync.noDirProp?dir:dir.directoryProperties;
    oldPrefName = gAddressbooksSync.noDirProp?dirProp.dirPrefId:dirProp.prefName;
    gAddressbooksSync.deleteAddressBook(dir);
//dump(mabName+' deleted\n');
  }

  // TB3 (at least Shredder alpha 1) has a problem with maillist, if the same
  // mab filename is reused (listnames and contents might contain old contents!)
  // In TB2, if we don't change the filename, we  need a timegap before
  // calling createAddressBook()
  var m=mabFile.match(/(.*?)(_abs(\d+))?\.mab/);
  var num=1; if (m[3]) num=Number(m[3])+1; if (num==10000) num=1;
  mabFile=m[1]+'_abs'+num+'.mab';

  //  copy the (temp) file in place
  var nsIMabFile = getDir('ProfD');
  var path=nsIMabFile.path;
  nsIMabFile.appendRelativePath( mabFile );
  if (nsIMabFile.path==path) {
   var err='Internal error: error creating path to addressbook "'+mabName+'" with filename "'+mabFile+'"';
   alert(err);
   return err;
  }
  if (nsIMabFile.exists() && nsIMabFile.isFile())
    try { nsIMabFile.remove(false); }
    catch(e) { return e.message; }
  file.copyTo( getDir('ProfD'), mabFile );
  nsIMabFile.permissions=0x666;

//dump(file.path+' copied to '+mabFile+'\n');
  statustxt('.',0, false);

  var newDir=gAddressbooksSync.createAddressBook( mabName, mabFile );
  statustxt('.',0, false);
  if (dir) {  //prefName might have changed!
    var dirProp = gAddressbooksSync.noDirProp?newDir:newDir.directoryProperties;
    var newPrefName = gAddressbooksSync.noDirProp?dirProp.dirPrefId:dirProp.prefName;
    if (oldPrefName!=newPrefName) {
dump('prefName changed: old='+oldPrefName+' new='+newPrefName+'\n');
      var prefBranch = gPrefService.getBranch("extensions.addressbookssync.");
      var sync;
      try { sync = prefBranch.getBoolPref( oldPrefName+".up" ); } catch(e) { sync=false; }
      prefBranch.setBoolPref( newPrefName+".up", sync );
      try { sync = prefBranch.getBoolPref( oldPrefName+".down" ); } catch(e) { sync=false; }
      prefBranch.setBoolPref( newPrefName+".down", sync );
      try { sync = prefBranch.getBoolPref( oldPrefName+".filename" ); } catch(e) { sync=false; }
      prefBranch.setBoolPref( newPrefName+".filename", sync );
      try { prefBranch.deleteBranch(oldPrefName); } catch(e) {};
    }
  }
//dump(mabName+' created\n');
  return '';
}

/*
 * replace content of an address book with given data
 */
function replaceAddressBook_viaEntry(mabName, mabFile, file)
{
dump('---replaceAddressBook_viaEntry\n');
  var dir=gAddressbooksSync.getAddressBook(mabFile);  //dir=nsIAbDirectory
  if (!dir) return 'failed to find addressbook';
//  statustxt("+", 0, false, null); //

  gAddressbooksSync.removeListener();

dump('clear addressbook\n');
//dumpDir(dir, 'At Start:');
  var ret=gAddressbooksSync.clearAddressBook(dir);
  if (ret) return ret;
//  statustxt("+", 0, false, null); //

dump('fill addressbook\n');
  ret=gAddressbooksSync.fillAddressBook(dir, file);
  if (ret) return ret;

dump('---Replace done\n');

  dir.lastModifiedDate=gAddressbooksSync.appstarttime; //set to 'not modified'
  gAddressbooksSync.addListener();
  return '';
}

function getLastModified(dir) {  //dir=nsIAbDirectory
  if (!dir) return 0;

  var lastModifiedDate=dir.lastModifiedDate;  //set via abs_gAbSessionListener
dump('abs: last modified date of dir '+dir.dirName+': '+lastModifiedDate+'\n');
  var count=0;
  var email='';
  try  {
    var cardsE=dir.childCards;
    var cards = Components.classes["@mozilla.org/supports-array;1"].
      getService(Components.interfaces.nsISupportsArray);
      //convert nsIEnumerator to nsISupportsArray (don't try dir.dropCard()!)
    var goon=1;
      // Loop over the cards
    try { cardsE.first() } catch (e) { goon=0; }
    while (goon) {
      var card = cardsE.currentItem().QueryInterface(Components.interfaces.nsIAbCard);
      var lmt=card.lastModifiedDate;
      if (lmt>lastModifiedDate) {
        lastModifiedDate=lmt;
        email=card.primaryEmail;
      }
      count++;
      try { cardsE.next() } catch(e) { goon=0; }
    }
  } catch(e) { alert('getLastModified: '+e); }
if (email) dump('abs: last modified date of email '+email+': '+lastModifiedDate+'\n');
  return lastModifiedDate;
}

/*
 * return URI for remote syncronization
 */
function getSyncURI(masked)
{
  var syncpassword='';
  var syncprotocol = gAddressbooksSync.protocol;
  var synchost = gAddressbooksSync.host;
  var syncuser = gAddressbooksSync.user;
  var syncpath = gAddressbooksSync.path;

  var syncpassword='';
  if (masked) {
    syncpassword='**********';
  } else
    try{ syncpassword = get_password(syncprotocol, synchost, syncuser); } catch(e) {}

  if( ! synchost )
    return "";
  var userpass=encodeURIComponent(syncuser) +(syncpassword?":":"")+encodeURIComponent(syncpassword);
  if(userpass)
    userpass += "@";
  var uri=syncprotocol + "://" + userpass + synchost + syncpath+'/';

  return uri;
}

/*
 *  get a special Directory, 'ProfD' or 'TmpD'
 */
function getDir(special) {
/*
  var profileFolder = directoryService.get(special,  Components.interfaces.nsIFile);
  var profileDir = profileFolder.QueryInterface(Components.interfaces.nsILocalFile);
  var nsIMabFile = profileDir.clone().QueryInterface(Components.interfaces.nsILocalFile);
*/
  var dir = gDirectoryService.get(special,  Components.interfaces.nsIFile)
    .QueryInterface(Components.interfaces.nsILocalFile);
//  return dir.clone().QueryInterface(Components.interfaces.nsILocalFile);
  return dir;
}

function deleteTempFile(filename) {
  var nsITmpFile=getDir('TmpD');
  nsITmpFile.appendRelativePath(filename);
  if (!nsITmpFile.exists() || !nsITmpFile.isFile()) return true;
  var deleted=false;
  try { nsITmpFile.remove(false) }
  catch(e) {
    switch (e.result) {
      case Components.results.NS_ERROR_FILE_ACCESS_DENIED:
    //  after call to replaceAddressBook, an immediate remove
    //  throws an 'access denied'
//        setTimeout(deleteTempFile, 1000, filename, count);
        break;
      case Components.results.NS_ERROR_FILE_NOT_FOUND:
        deleted=true;
        break;
      default:
        alert('deleteTempFile: '+e.message);
        deleted=true; // not really
        break;
    }
    return deleted;
  }
  return true;
}

function getTimeStamp()
{
    var date = new Date();
    return Math.floor( date.getTime() / 1000 );

} // getTimeStamp

function timeString(time) { //time in seconds
  var d=time?new Date(time):new Date();;
  //var s=d.toLocaleString();
  var s=d.toLocaleFormat('%d.%b.%Y %H:%M:%S');
  return s;
}

function errorstr(aError)
{
  var error;

  var intErr=0;
  if (typeof aError == 'string') {
    var err=Number(aError);
    if (!isNaN(err)) aError=err;
  }
  //Errorcodes:
  //    xpcom/base/nsError.h
  //    netwerk/base/public/nsNetError.h
  switch(aError){
  // internal errors
    case -1:
      intErr=1;
      error=strings.getString('unexperr'); // 'unexpected initialization error';
      break;
    case -2:
      intErr=2;
      error=strings.getString('localreaderr'); // 'local mab file read error';  //access denied (also gives unhandled exception), does not exist
      break;
    case -3:
      intErr=3;
      error=strings.getString('illimap');
      break;
  //Thunderbird network error, see netwerk/base/public/nsNetError.h
    case 0x804b000d:
      //NS_ERROR_CONNECTION_REFUSED 13
      //The connection attempt failed, for example, because no server was listening
      //at specified host:port.
      intErr=4;
      error=strings.getString('protnotavail'); // 'protocol not available';
      break;
    case 0x804b000e:
        //NS_ERROR_NET_TIMEOUT 14
        //The connection was lost due to a timeout error.
      intErr=12;
      error=strings.getString('timeout'); // 'timeout';
      break;
    case 0x804b0011:
      //NS_ERROR_NO_CONTENT 17
      intErr=16;
      error='No content';
        // used, when Firefox is set as 'network.protocol-handler.app.ftp'
        // for FTP. The addressbook is shown in Firefox!
      break;
    case 0x804b0012:
      //NS_ERROR_UNKNOWN_PROTOCOL 18
      // The URI scheme corresponds to an unknown protocol handler.
      intErr=17;
      error='Unknown protocol handler';
      // happens after removing application-handler after NS_ERROR_NO_CONTENT
      break;
    case 0x804b0015:
      //NS_ERROR_FTP_LOGIN 21
      intErr=10;
      error=strings.getString('illcred'); // illegal credentials';
      break;
    case 0x804b0016:
      //NS_ERROR_FTP_CWD 22
      intErr=15;
      error=strings.getString('nofile');
      break;
//NS_ERROR_FTP_PASV 23
//NS_ERROR_FTP_PWD 24
//NS_ERROR_FTP_LIST 25
    case 0x804b001e:
      //NS_ERROR_UNKNOWN_HOST 30
      intErr=5;
      error=strings.getString('hostnotfound'); // 'host not found';
      break;
    case 0x804b002a:
      //NS_ERROR_UNKNOWN_PROXY_HOST 42
      intErr=13;
      error=strings.getString('proxynotfound'); // 'proxy not found';
      break;
    case 0x804b0048:
      //NS_ERROR_PROXY_CONNECTION_REFUSED 72
      intErr=14;
      error=strings.getString('proxyerr'); // 'proxy error';
      break;
  //external errors (server error, windows error)
    case 0x80004002:
      /* NS_ERROR_NO_INTERFACE: Returned when a given interface is not supported. */
      intErr=18;
      error='External application handler set';
        //This happens on ftp upload when an external handler is set
      break;
    case 0x80004005:
      /* NS_ERROR_FAILURE: Returned when a function fails */
      intErr=6;
      error=strings.getString('permdenied'); // frher 'fileunavail', file unavailable
        //??? (with FTP: Error 550: File unavailable (e.g., file not found, no access).
        //(with IMAP: wenn der alte Upload mit 'CopyFileMessage' verwendet wird)
      break;
    case 405:
      intErr=7;
      error=strings.getString('methodnotallowed'); // method not allowed';  //method is something like PUT,POST or GET
      break;
    case 404:
      intErr=8;
      error=strings.getString('notfound'); // not found';
      break;
    case 403:
      intErr=9;
      error=strings.getString('permdenied'); // permission denied';
      break;
    case 401:
      intErr=11;
      error=strings.getString('illcred'); // illegal credentials';
      break;
    case 0:
    case 201:
    case 204:
      error=strings.getString('ok');
      break;
    default:
      var sError;
      if (aError&0xffff0000) {
        if ((aError>>>16)==0x804b)  //TB Netzwerk errors, see netwerk/base/public/nsNetError.h
          sError='TB-'+(aError&0xffff).toString(10);
        else
          sError='0x'+aError.toString(16);
      } else
        sError=aError;
      error='Error '+sError;
      break;
  }
//  throws 'no memory' exception
//  var errorService = Components.classes["@mozilla.org/xpcom/error-service;1"].
//            getService(Components.interfaces.nsIErrorService);
//  error+=' ('+errorService.getErrorStringBundleKey(aError)+')';
  if (intErr) error+=' ('+intErr+')';
  return error;
}

var line;
var lastnewline;
function statustxt(aStatus, newline, doalert, longText, addText)
  //newline: 1: start a new line, 2: end a line, 3:both, 0: append to line
  //          -1: Start of new sequence, -2 End of sequence
{
  if (doalert) gLifeTime=5; //show window a little bit longer
                            //this should really be done somehwere else ;-)

  if (newline==-2 && lastnewline==-2) return;

  var now; var appStart;
  if (newline==-1) {
    now = timeString();
    appStart = timeString(gAddressbooksSync.appstarttime*1000);
    appStart = 'Thunderbird start '+appStart;
    gAddressbooksSync.statusText=null;
    gAddressbooksSync.statusText=now+'\n';
    gAddressbooksSync.statusText=appStart+'\n';
  }
  gAddressbooksSync.statusText=longText?longText:aStatus;
  if (addText) gAddressbooksSync.statusText=' ('+addText+') ';
  if (newline&2 || newline<0) gAddressbooksSync.statusText="\n";

  // popup menu
  if (gUsesPopup) {
    var status=document.getElementById("status");
    if (status) {
      if (newline==-1) status.value=(longText?longText:aStatus)+'\n';
      else if (newline==-2) status.value+=(longText?longText:aStatus)+'\n';
      else if (newline>=0) {
        status.value+=(longText?longText:aStatus);
        if (newline&2) status.value += "\n";
        status.inputField.scrollTop=status.inputField.scrollHeight;
      }
    }
  }

  //status bar
  if (!gStatusbar) {
    var w=window;
    try { // will fail on onUnload
      while (w && w.location!='chrome://messenger/content/messenger.xul') w=w.opener;
    } catch(e) { w=null; }
//  var maindoc = window.location!=?window.opener.document:document;
//alert(maindoc.location);
//  if (maindoc && maindoc.location=='chrome://messenger/content/options.xul') maindoc=maindoc.opener.document;
    if (w)
      gStatusbar=w.document.getElementById("statusText");
  }
  if (gStatusbar) {  //at onUnload gibts das nicht mehr!
    if (newline==-1) gStatusbar.label=aStatus+'  ';
    if (newline==-2) gStatusbar.label+='  '+aStatus;
    if (newline>=0) {
      gStatusbar.label+=aStatus;
      if (newline&2) gStatusbar.label+='  ';
    }
  }

  aStatus=longText?longText:aStatus;
  if (addText) aStatus+=' ('+addText+') ';

  //error console
  if (newline==-2)
    console.logStringMessage('AddressbooksSynchronizer '+gAddressbooksSync.version+': '+gAddressbooksSync.statusText);

//////////////
  if (gAddressbooksSync.exiting && newline==-2) {
    var fline='AddressbooksSynchronizer '+gAddressbooksSync.version+': '+gAddressbooksSync.statusText;
    var flags=0x10|0x08|0x02;
          // 0x02=PR_WRONLY, 0x10=PR_APPEND, 0x08=PR_CREATE_FILE
    try {
      var logFile = getDir('TmpD');
      logFile.appendRelativePath( 'AddressbookSynchronizer.log' );
      var strm = Components.classes["@mozilla.org/network/file-output-stream;1"].
        createInstance(Components.interfaces.nsIFileOutputStream);
      strm.QueryInterface(Components.interfaces.nsIOutputStream);
      strm.QueryInterface(Components.interfaces.nsISeekableStream);
      strm.init( logFile, flags, 0600, 0 );
      strm.write( fline, fline.length );
      strm.flush();
      strm.close();
    } catch(e) { console.logStringMessage('AddressbooksSynchronizer: '+'File write:\n'+e+'\n'); }
  }
////////////

  lastnewline=newline;
  if (doalert)
    alert(gAddressbooksSync.statusText);
}

function refreshAddressbook(what) {
  // refresh addressbook view
  var windowsEnum = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService()
                   .QueryInterface(Components.interfaces.nsIWindowMediator)
                   .getEnumerator("mail:addressbook");
  while (windowsEnum.hasMoreElements()) {
dump('Found Addressbook Window\n');
    var w=windowsEnum.getNext();
    var abTree=w.document.getElementById("dirTree");
    if (abTree) { //isn't there a better way?
      var oi=abTree.view.selection.currentIndex;
      var ni=oi?oi-1:abTree.view.rowCount-1;
      //from abCommon.js
      abTree.view.selection.select(ni);
      w.ChangeDirectoryByURI(w.GetSelectedDirectory());
      w.gAbResultsTree.focus();
      abTree.view.selection.select(oi);
      w.ChangeDirectoryByURI(w.GetSelectedDirectory());
      w.gAbResultsTree.focus();
    } else {
dump('abs: refreshAddressbook: no abTree\n');
    }
  }
}

function showOptions()
{
  var windowsEnum = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService()
                   .QueryInterface(Components.interfaces.nsIWindowMediator)
                   .getEnumerator("addressbookssync-options");
  var options=windowsEnum.getNext();
  if (options)
    options.focus();
  else
    window.open("chrome://addressbookssync/content/options.xul","_blank","chrome,resizable,titlebar=yes");
}

/*
 *  This is, where every up-/download starts!
 */
function showPopup(direction, singlebook, usepopup, automatic, force)
{
  //singlebook: a mabFile or null
  //usepopup: if true, use popups, else ask property 'hidepopups'
  //automatic: true, if its an automatic down-/upload and programmstart/-end
  //force: if true, upload mabs, even if not changed
  if (direction=='upload' && gAddressbooksSync.noupload) return;
  if (!singlebook && gAddressbooksSync.syncedAddressbooks((direction=='download')?'down':'up',null).Count()==0)
    return;  //nothing to do

//TODO: possible race condition!
  if (gAddressbooksSync.state!='') {  // we are already doing an up-/download
    if (!automatic) {
      var strings = document.getElementById("ggbs_abs_strings");
      alert(strings.getString('inprogress'));
    }
    return;
  }

  gUsesPopup=usepopup || !gAddressbooksSync.hideallpopups;
//  if (!usepopup) hidepopups = gAddressbooksSync.hidepopups;

  gAddressbooksSync.state=direction;

  if (!gUsesPopup) {
    if (direction=='download') download(singlebook, force);    //in download.js
    else                       upload(singlebook, force);      //in upload.js
  } else {
    var x=Math.floor(window.outerWidth/2+window.screenX);
    var y=Math.floor(window.outerHeight/2+window.screenY);
    var w=window.openDialog("chrome://addressbookssync/content/"+direction+".xul","_blank",
      'chrome,resizable,titlebar=no', singlebook, force);
//if adding more arguments: update in call to upload() and download() above
//    AND in upload.xul and download.xul!!
  }
}

function checkOffline(direction) {
  if (ioService.offline) {
    var windowsEnum = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService()
                     .QueryInterface(Components.interfaces.nsIWindowMediator)
                     .getEnumerator("mail:3pane");  //.getMostRecentWindow("mail:3pane")
    var w=windowsEnum.getNext();  // there must be one (the current)! (really? what if tb killed)
    if (!w) {
      gAbort=2;
      killMe();
      return false;
    }
    var goOnline = direction=='upload' ?
        w.PromptSendMessagesOffline() : w.PromptGetMessagesOffline();
    if(goOnline==0) {
      if (!w.gOfflineManager)
        w.GetOfflineMgrService();
      w.gOfflineManager.goOnline(false /* sendUnsentMessages */,
                             false /* playbackOfflineImapOperations */,
                             w.msgWindow);
    } else {
      gAbort=2;
      killMe();
      return false;
    }
  }
  return true;
}

function killMe()
{
  //gAbort=0: normales ende
  //gAbort=1: aborted
  //gAbort=2: killed
//dump('abs: killMe '+gAbort+' '+(cleanUp)+'\n');

  if (gAbort<2 && cleanUp) {
    cleanUp();
    cleanUp=null;
  }
  if (gTempName && !gAbort) {
    if (!deleteTempFile(gTempName)) {
      setTimeout(killMe,1000);
      return;
    } else {
      gTempName='';
    }
  }

  if (gAbort==1)
    // this does not fire on unexpected errors, since
    // killMe is probably not called from processing loop
    statustxt(strings.getString('aborted'), -2, false);
  else if (!gAddressbooksSync.state) //kommt sonst bei imap 2x (wenn compacting asynchron)
    statustxt(strings.getString('ok'), -2, false);

  gAddressbooksSync.state=''; //Up-/Download ready

//  if(gLifeTime>0 && gUsesPopup && gAbort<2) {
  if(gLifeTime>0 && gAbort<2) {
    setTimeout(killMe,gLifeTime*1000);
    gLifeTime=0;
    return;
  }

/* lschen der Statuszeile eventuell timer gesteuert! */
  if (gStatusbar) {  //at onUnload gibts das nicht mehr!
    gStatusbar.label='';
  }

  if (gAddressbooksSync.pendingupload) {
//    gAddressbooksSync.pendingupload=false;
    showPopup('upload', null, false, true, false);
  }

//    alert(gAddressbooksSync.statusText);
//if (gAbort==2)  //test
  if (gUsesPopup) setTimeout(close,0);
}

function disableUpload() {
  //Toolbar button in 3Pane window and(!) addressbook window
  var id=document.getElementById('ggbs_abs_UploadIcon');
  if (id) id.style.display='none';
  //Context menuitem in addressbook
  id=document.getElementById('ggbs_abs_ContextUpload');
  if (id) id.style.display='none';
  //Menuitems in addressbook
  id=document.getElementById('ggbs_abs_TaskUploads');
  if (id) id.style.display='none';
  id=document.getElementById('ggbs_abs_TaskUpload');
  if (id) id.style.display='none';
  //Upload now button in Options
  id=document.getElementById('autouploadnow');
  if (id) id.style.display='none';
  //checkbox 'Automatic upload'
  id=document.getElementById('autoupload');
  if (id) id.style.display='none';
  //checkbox 'Timed upload'
  id=document.getElementById('timedupload');
  if (id) id.style.display='none';
  //export
  id=document.getElementById('export');
  if (id) id.style.display='none';
  //checkbox for seperate Up-/download disablen
  id=document.getElementById('separateupdown');
  if (id) id.style.display='none';
  //Strategy for IMAP Upload disablen
  id=document.getElementById('imappolicy');
  if (id) id.style.display='none';
  //...
}

function askOverwrite(cur, alwaysask) {
  var dummy=new Object;
  if (gAddressbooksSync.noDirProp) {
    var b=gPrefService.getBranch(cur.dirPrefId+'.');
    try { description = b.getCharPref( 'description' ); } catch(e) { description=cur.dirPrefId; }
  } else {
    var description=cur.directoryProperties.description;
  }
  if (alwaysask) {
    return prompter.confirmEx(window, 'Load '+description,
        strings.getString('mab')+' "'+description+'":\n'+strings.getString('askoverwrite'),
//          (BUTTON_POS_0) * (BUTTON_TITLE_YES) + (BUTTON_POS_1) * (BUTTON_TITLE_NO) + BUTTON_POS_0_DEFAULT
            (1)            * (3)                + (256)          * (4)               + 0,
            null, null, null, null, dummy
        )
  }
  if (gAddressbooksSync.appstarttime<getLastModified(cur) &&
      (gAddressbooksSync.downloadpolicy=='keep' ||
            gAddressbooksSync.downloadpolicy=='ask' &&
            prompter.confirmEx(window, 'Download '+description,
                strings.getString('mab')+' "'+description+'":\n'+strings.getString('askmodified'),
//                  (BUTTON_POS_0) * (BUTTON_TITLE_YES) + (BUTTON_POS_1) * (BUTTON_TITLE_NO) + BUTTON_POS_0_DEFAULT
                    (1)            * (3)                + (256)          * (4)               + 0,
                    null, null, null, null, dummy
                )
          )) {
    return false; //skip
  } else
    return true;  //overwrite
}

/*
 *  Debug only, dump content of a directory
 */
function dumpDir(dir, text) {
  dump(text+'\n');
  var lists=dir.childNodes;
  var count=0;
  while( lists.hasMoreElements() ) {
    var list = lists.getNext().QueryInterface(Components.interfaces.nsIAbDirectory);
    count++;
    var listProp = gAddressbooksSync.noDirProp?list:list.directoryProperties;
    dump('  listDir '+list.dirName+' '+listProp.URI+'\n');
  }
  lists=null;
  if (!count) dump('  No listDir\n');

  count=0;
  try {
    var cardsE=dir.childCards;
    var cards=0;
    if (cardsE.hasMoreElements) { //since TB3a
      // cardsE is a nsISimpleEnumerator
      while( cardsE.hasMoreElements() ) {
        var card=cardsE.getNext();
        if (card.isMailList) {
          dump('  listCard '+card.mailListURI+'\n');
          count++;
        } else
          cards++;
      }
    } else {
      // cardsE is a nsIEnumerator
      var goon=1;
        // Loop over the cards
      try { cardsE.first() } catch (e) { goon=0; }
      while (goon) {
        var card = cardsE.currentItem().QueryInterface(Components.interfaces.nsIAbCard);
        if (card.isMailList) {
          dump('  listCard '+card.mailListURI+'\n');
          count++;
        } else
          cards++;
        try { cardsE.next() } catch(e) { goon=0; }
      }
    }
    if (!count) dump('  No listCards\n');
    dump('  # normal cards '+cards+'\n');
  } catch(e) { dump(' childCards throws exception\n'); }  //when called with temp
}
