/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AddressbooksSynchronizer.
 *
 * The Initial Developer of the Original Code is G�nter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  G�nter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var gStrings;
var gPrefService = Components.classes["@mozilla.org/preferences-service;1"].
  getService(Components.interfaces.nsIPrefService);

var gInitDone=false;

var panel=gAddressbooksSync.noDirProp?'':'_2';  // TB3 uses the panel, TB2 the menupopup

function abs_init()
{
	//enable the enterfilename panel for TB3
    if (!panel) document.getElementById('gg-bookmarksSync-ef').hidden=false;

    var doc;
    if (document.getElementById("synclocal")) doc=document;
    else doc=window.opener.document;  //called from popup

    var prefBranch = gPrefService.getBranch("extensions.addressbookssync.");

    gStrings = document.getElementById("ggbs_abs_strings");

    var syncpassword='';

    var synctype = gAddressbooksSync.synctype;
    var localpath = gAddressbooksSync.localpath;
    var syncprotocol = gAddressbooksSync.protocol;
    var synchost = gAddressbooksSync.host;
    var syncuser = gAddressbooksSync.user;
    syncpassword = '**********';
    var syncpath = gAddressbooksSync.path;
    var syncimap = gAddressbooksSync.imapfolder;
    var syncpolicy = gAddressbooksSync.syncpolicy;
    var imappolicy = gAddressbooksSync.imapusedraft;

    if (synctype=='local') {
      doc.getElementById("synctype").selectedItem=doc.getElementById("synclocal");
      doc.getElementById("absTabs").selectedIndex=0;
      doc.getElementById("absTab").selectedIndex=0;
    } else if (synctype=='remote') {
      doc.getElementById("synctype").selectedItem=doc.getElementById("syncremote");
      doc.getElementById("absTabs").selectedIndex=1;
      doc.getElementById("absTab").selectedIndex=1;
    } else if (synctype=='imap') {
      doc.getElementById("synctype").selectedItem=doc.getElementById("syncimap");
      doc.getElementById("absTabs").selectedIndex=2;
      doc.getElementById("absTab").selectedIndex=2;
    }

    doc.getElementById("localpath").value = localpath;

    doc.getElementById("protocol").value = syncprotocol;
    doc.getElementById("host").value = synchost;
    doc.getElementById("username").value = syncuser;
    doc.getElementById("password").value = syncpassword;
    doc.getElementById("path").value = syncpath;

    PickedMsgFolder(syncimap, doc);

    doc.getElementById("autoupload").checked = gAddressbooksSync.autoupload;
    doc.getElementById("autodownload").checked = gAddressbooksSync.autodownload;
    doc.getElementById("timedupload").checked = gAddressbooksSync.timedupload;
    doc.getElementById("timeddownload").checked = gAddressbooksSync.timeddownload;
    doc.getElementById("loadtimer").value = gAddressbooksSync.loadtimer;

    if (syncpolicy=='entry')
      doc.getElementById("syncpolicy").selectedItem=doc.getElementById("syncpolicyentry")
    else if (syncpolicy=='file')
      doc.getElementById("syncpolicy").selectedItem=doc.getElementById("syncpolicyfile")

    if (imappolicy)
      doc.getElementById("imappolicy").selectedItem=doc.getElementById("imappolicydraft")
    else
      doc.getElementById("imappolicy").selectedItem=doc.getElementById("imappolicyfile")
    doc.getElementById("separateupdown").checked = gAddressbooksSync.separateupdown;

    var downloadpolicy=gAddressbooksSync.downloadpolicy;
    if (downloadpolicy=='ask')
      doc.getElementById("downloadpolicy").selectedItem=doc.getElementById("downloadpolicyask")
    else if (downloadpolicy=='overwrite')
      doc.getElementById("downloadpolicy").selectedItem=doc.getElementById("downloadpolicyoverwrite")
    else if (downloadpolicy=='keep')
      doc.getElementById("downloadpolicy").selectedItem=doc.getElementById("downloadpolicykeep")

    // list address books
    var mabList = doc.getElementById("MabList");
    var mabList1 = doc.getElementById("MabList1");
    var syncList = doc.getElementById("SyncListCheck");
    //just in case
    mabList.removeAllItems();
    mabList1.removeAllItems();
    while (syncList.firstChild)
      syncList.removeChild(syncList.firstChild);
    doc.getElementById("SyncLiscDesc").style.visibility =
      (gAddressbooksSync.separateupdown?'visible':'hidden');

    // get all MAB Files
    var selectedMAB='???.mab';
    var mabDirs=gAddressbooksSync.syncedAddressbooks('all','');

    for (var i = 0; i < mabDirs.Count(); i++) {
      var mabDir=mabDirs.GetElementAt(i).QueryInterface(Components.interfaces.nsIAbDirectory);
      var dirProp = gAddressbooksSync.noDirProp?mabDir:mabDir.directoryProperties;
      var prefName = gAddressbooksSync.noDirProp?dirProp.dirPrefId:dirProp.prefName;
      var description=mabDir.dirName;
      var mabFile=dirProp.fileName;

      mabList.appendItem( description, mabFile, "" ); // 'Store'
      mabList1.appendItem( description, mabFile, "" ); // 'Store'

      //'Sync'
      var hb=doc.createElement('hbox');
      if (gAddressbooksSync.separateupdown) {
        var ncb1=doc.createElement('checkbox');
        ncb1.setAttribute('id', 'addressbookssync_'+description+'_up');
        ncb1.setAttribute('label', null);
        hb.appendChild(ncb1);
      }
      var ncb=doc.createElement('checkbox');
      ncb.setAttribute('id', 'addressbookssync_'+description);
      hb.appendChild(ncb);
      var l=doc.createElement('label');
      l.setAttribute('value', description);
      l.setAttribute('context', 'gg-bookmarksSync-ef'+panel);
      hb.appendChild(l);

      syncList.appendChild( hb );

      var sync=false;
      if (!gAddressbooksSync.separateupdown) {
        try { sync = prefBranch.getBoolPref( prefName+".down" ); } catch(e) { sync=false; }
        if (sync) {
          ncb.setAttribute('checked', true);
          selectedMAB=gAddressbooksSync.externalFilename(mabDir); //description;
        }
      } else {
        try { sync = prefBranch.getBoolPref( prefName+".up" ); } catch(e) { sync=false; }
        if (sync) {
          ncb1.setAttribute('checked', true);
          selectedMAB=gAddressbooksSync.externalFilename(mabDir); //description;
        }
        try { sync = prefBranch.getBoolPref( prefName+".down" ); } catch(e) { sync=false; }
        if (sync) {
          ncb.setAttribute('checked', true);
          selectedMAB=gAddressbooksSync.externalFilename(mabDir); //description;
        }
      }
    } // for
    mabList.selectedIndex = 0;
    mabList1.selectedIndex = 0;

    doc.getElementById("URI").value = encodeURI(getSyncURI(true)+selectedMAB);

    var usepost = gAddressbooksSync.usepost;
    doc.getElementById("usepost").checked = usepost;

    doc.getElementById("notimecheck").checked = !gAddressbooksSync.checkLastModTime;
    doc.getElementById("hidepopups").checked = gAddressbooksSync.hidepopups;
    doc.getElementById("hideallpopups").checked = gAddressbooksSync.hideallpopups;
    doc.getElementById("noupload").checked = gAddressbooksSync.noupload;

    if (gAddressbooksSync.noupload) disableUpload();
    gInitDone=true;

} // init

function enter_externalfilename() {
  var dirName=document.popupNode.value;
  var l=document.getElementById("gg-bookmarksSync-ef-l"+panel);
  l.value=dirName;
  var tb=document.getElementById("gg-bookmarksSync-ef-t"+panel);
  var dir=gAddressbooksSync.getAddressBook(dirName);
  tb.value=gAddressbooksSync.externalFilename(dir);
}
function set_externalfilename() {
  var dirName=document.popupNode.value;
  var tb=document.getElementById("gg-bookmarksSync-ef-t"+panel);
  var dir=gAddressbooksSync.getAddressBook(dirName);
  tb.value=gAddressbooksSync.setExternalFilename(dir, tb.value);
  document.getElementById("gg-bookmarksSync-ef"+panel).hidePopup();
}



function abs_finish()
{
    if (!gInitDone) return;

    var prefBranch = Components.classes["@mozilla.org/preferences-service;1"].
      getService(Components.interfaces.nsIPrefService).
      getBranch("extensions.addressbookssync.");

    if (!document.getElementById("localpath")) return;  // called via toolbar buttons

    var localpath=document.getElementById("localpath").value;
    gAddressbooksSync.localpath=localpath;
    if ( document.getElementById("synclocal").selected && localpath) {
      if (gAddressbooksSync.synctype!='local') {
        gAddressbooksSync.forceUpload=true;
        gAddressbooksSync.forceDownload=true;
      }
      gAddressbooksSync.synctype='local';
    } else if ( document.getElementById("syncremote").selected ) {
      if (gAddressbooksSync.synctype!='remote') {
        gAddressbooksSync.forceUpload=true;
        gAddressbooksSync.forceDownload=true;
      }
      gAddressbooksSync.synctype='remote';
    } else if ( document.getElementById("syncimap").selected ) {
      if (gAddressbooksSync.synctype!='imap') {
        gAddressbooksSync.forceUpload=true;
        gAddressbooksSync.forceDownload=true;
      }
      gAddressbooksSync.synctype='imap';
    } else {
      gAddressbooksSync.synctype='none';
      document.getElementById("synctype").selectedItem=null;
    }

    gAddressbooksSync.protocol=document.getElementById("protocol").value;
    var host=document.getElementById("host").value;  gAddressbooksSync.host=host;
    var user=document.getElementById("username").value; gAddressbooksSync.user=user;
    var pwd=document.getElementById("password").value;
    if (pwd!='**********') set_password(gAddressbooksSync.protocol, host,user,document.getElementById("password").value );
    gAddressbooksSync.path=document.getElementById("path").value;
    gAddressbooksSync.imapfolder=document.getElementById("syncimapPicker").getAttribute("uri");

    var v=document.getElementById("autoupload").checked;
    if (!gAddressbooksSync.autoupload && v) gAddressbooksSync.forceUpload=true;
    gAddressbooksSync.autoupload=v;
    v=document.getElementById("autodownload").checked;
    if (!gAddressbooksSync.autodownload && v) gAddressbooksSync.forceDownload=true;
    gAddressbooksSync.autodownload=v;

    gAddressbooksSync.timedupload=document.getElementById("timedupload").checked;
    gAddressbooksSync.timeddownload=document.getElementById("timeddownload").checked;
    var timer=gAddressbooksSync.loadtimer;
    gAddressbooksSync.loadtimer=document.getElementById("loadtimer").value;

    if ( document.getElementById("syncpolicyentry").selected)
      gAddressbooksSync.syncpolicy='entry';
    else if ( document.getElementById("syncpolicyfile").selected )
      gAddressbooksSync.syncpolicy='file';

    if ( document.getElementById("imappolicydraft").selected)
      gAddressbooksSync.imapusedraft=true;
    else if ( document.getElementById("imappolicyfile").selected )
      gAddressbooksSync.imapusedraft=false;

    if ( document.getElementById("downloadpolicyask").selected)
      gAddressbooksSync.downloadpolicy='ask';
    else if ( document.getElementById("downloadpolicyoverwrite").selected )
      gAddressbooksSync.downloadpolicy='overwrite';
    else if ( document.getElementById("downloadpolicykeep").selected )
      gAddressbooksSync.downloadpolicy='keep';

    var old_separateupdown=gAddressbooksSync.separateupdown;
    gAddressbooksSync.separateupdown=document.getElementById("separateupdown").checked;

    var selectedMAB='???.mab';
    var mabDirs=gAddressbooksSync.syncedAddressbooks('all', '');
    for (var i = 0; i < mabDirs.Count(); i++) {
      var mabDir=mabDirs.GetElementAt(i).QueryInterface(Components.interfaces.nsIAbDirectory);
      var dirProp = gAddressbooksSync.noDirProp?mabDir:mabDir.directoryProperties;
      var description=mabDir.dirName;
      var mabFile=dirProp.fileName;
      var prefName = gAddressbooksSync.noDirProp?dirProp.dirPrefId:dirProp.prefName;
      if (!old_separateupdown) {
        var syncElem = document.getElementById('addressbookssync_'+description);
if (!syncElem) continue;  //New addressbook created, while options dialog open!
        if (syncElem.getAttribute('checked')) {
          var cbv;
          try { cbv=prefBranch.getBoolPref(prefName+".down"); } catch(e) { cbv=false; };
          gAddressbooksSync.forceUploadOf(mabFile, !cbv);
          prefBranch.setBoolPref( prefName+".down", true );
          prefBranch.setBoolPref( prefName+".up", true );
          selectedMAB=gAddressbooksSync.externalFilename(mabDir); //description;
        } else {
          prefBranch.setBoolPref( prefName+".down", false );
          prefBranch.setBoolPref( prefName+".up", false );
          gAddressbooksSync.forceUploadOf(mabFile, false);
        }
      } else {  // War separated
        var syncUpElem = document.getElementById('addressbookssync_'+description+'_up');
if (!syncUpElem) continue;  //New addressbook created, while options dialog open!
        var syncDownElem = document.getElementById('addressbookssync_'+description);
        if (!gAddressbooksSync.separateupdown) {  //jetzt aber nicht mehr!
          if (syncUpElem.getAttribute('checked') || syncDownElem.getAttribute('checked')) {
            // Wenn auch nur einer gechecked war: jetzt beide
            selectedMAB=gAddressbooksSync.externalFilename(mabDir); //description;
            gAddressbooksSync.forceUploadOf(mabFile, !prefBranch.getBoolPref(prefName+".up"));
            prefBranch.setBoolPref( prefName+".up", true );
            prefBranch.setBoolPref( prefName+".down", true );
          } else {
            gAddressbooksSync.forceUploadOf(mabFile, false);
            prefBranch.setBoolPref( prefName+".up", false );
            prefBranch.setBoolPref( prefName+".down", false );
          }
        } else {
          if (syncUpElem.getAttribute('checked')) {
            gAddressbooksSync.forceUploadOf(mabFile, !prefBranch.getBoolPref(prefName+".up"));
            prefBranch.setBoolPref( prefName+".up", true );
            selectedMAB=gAddressbooksSync.externalFilename(mabDir); //description;
          } else {
            prefBranch.setBoolPref( prefName+".up", false );
            gAddressbooksSync.forceUploadOf(mabFile, false);
          }
          if (syncDownElem.getAttribute('checked')) {
            prefBranch.setBoolPref( prefName+".down", true );
            selectedMAB=gAddressbooksSync.externalFilename(mabDir); //description;
          } else
            prefBranch.setBoolPref( prefName+".down", false );
        }
      }
    }
    if (typeof selectedMAB=='undefined') selectedMAB='???.mab'; //warum tritt das gelegentlich auf?
    document.getElementById("URI").value = encodeURI(getSyncURI(true)+selectedMAB);

    gAddressbooksSync.usepost=document.getElementById("usepost").checked;

    gAddressbooksSync.checkLastModTime=!document.getElementById("notimecheck").checked;
    gAddressbooksSync.hidepopups=document.getElementById("hidepopups").checked;
    gAddressbooksSync.hideallpopups=document.getElementById("hideallpopups").checked;
    gAddressbooksSync.noupload=document.getElementById("noupload").checked;

    pref.savePrefFile(null);  //save to prefs.js

    if (gAddressbooksSync.separateupdown!=old_separateupdown) abs_init(); // must rebuild!
} // finish



function ChooseFile()
{
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

  var x=gStrings.getString("choosefile");
  filePicker.init(window, x, nsIFilePicker.modeOpen);
  filePicker.appendFilter( gStrings.getString("mab") + " (*.mab)", "*.mab;" );

  if( filePicker.show() == nsIFilePicker.returnOK )
  {
    document.getElementById( "MabFilePath" ).value = filePicker.file.path;
    var mabFileName = filePicker.file.leafName;
    var mabName = mabFileName.substr( 0, mabFileName.lastIndexOf(".") );
    document.getElementById( "MabName" ).value = mabName;
  }
} // ChooseFile

function ChoosePath()
{
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

  filePicker.init(window, gStrings.getString("choosesyncdir"), nsIFilePicker.modeGetFolder);

  if( filePicker.show() == nsIFilePicker.returnOK )
  {
    document.getElementById( "localpath" ).value = filePicker.file.path;
    document.getElementById( "synctype" ).selectedItem=document.getElementById( "synclocal" );
  }
} // ChoosePath

function PickedMsgFolder(selection, useDoc) {
  var doc=useDoc?useDoc:document;
  var selectedUri = typeof selection=="string"?selection:selection.getAttribute('id');

  var picker=doc.getElementById('syncimapPicker');
  var msgfolder;
    //in TB3, throws error if selectedURI is empty, but not if illegal!?
  try { msgfolder = GetMsgFolderFromUri(selectedUri, true); }
  catch(e) { msgfolder=''; }
//TODO: if (selectedFolder.server.type != "imap")

  if (!msgfolder)
    return;

  var selectedValue = null;
  var serverName;

  if (msgfolder.isServer)
    selectedValue = msgfolder.name;
  else {
    if (msgfolder.server)
      serverName = msgfolder.server.prettyName;
    else {
     dump("Can't find server for " + uri + "\n");
     serverName = "???";
    }
    var gMessengerBundle = doc.getElementById("bundle_messenger");
    selectedValue = gMessengerBundle.getFormattedString("verboseFolderFormat",
        [msgfolder.name, serverName]);
  }

  picker.setAttribute("label",selectedValue);
  picker.setAttribute("uri",selectedUri);
}

function SaveMab()
{
    var mabFile = document.getElementById( "MabList" ).selectedItem.value;
    var mabName = document.getElementById( "MabList" ).selectedItem.label;

    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var filePicker = Components.classes["@mozilla.org/filepicker;1"].
      createInstance(nsIFilePicker);

    var externMabFileName = mabName + ".mab";
    filePicker.defaultString = externMabFileName;
    filePicker.init(window, gStrings.getString("choosefiledest"), nsIFilePicker.modeSave);
    filePicker.appendFilter( gStrings.getString("mab") + " (*.mab)", "*.mab;" );
//    filePicker.appendFilter( 'CSV' + " (*.csv)", "*.csv;" );
//    filePicker.appendFilter( 'LDIF' + " (*.ldif)", "*.ldif;" );

    if( filePicker.show() != nsIFilePicker.returnCancel) { //Ok or Replace!
      var ret;
      switch (filePicker.filterIndex) {
        case 0:
          ret=saveMabFile( mabName, mabFile, filePicker.file.parent, filePicker.file.leafName );
          break;
/*  leider sind die export Funktionen von Javascript aus nicht zug�nglich :-(
    lediglich ab.exportAddressBook() ist verf�gbar, aber das poppt ein
    FilePicker auf
*/
/*
        case 1:
          var cur=gAddressbooksSync.getAddressBook(mabFile);
          var ab = Components.classes["@mozilla.org/addressbook;1"].  //gibts in TB3 nicht mehr! ggf. in nsIAbManager
            getService(Components.interfaces.nsIAddressBookExport);
          var file=filePicker.file;
          //TODO: eventuell umbenennen statt l�schen
          if (file.exists() && file.isFile()) { file.remove(false); }
          ret=ab.ExportDirectoryToDelimitedText(cur,';',1,file);
          break;
        case 2:
          var cur=gAddressbooksSync.getAddressBook(mabFile);
          var ab = Components.classes["@mozilla.org/addressbook;1"].  //gibts in TB3 nicht mehr! ggf. in nsIAbManager
            getService(Components.interfaces.nsIAddressBookExport);
          var file=filePicker.file;
          //TODO: eventuell umbenennen statt l�schen
          if (file.exists() && file.isFile()) { file.remove(false); }
          ret=ab.ExportDirectoryToLDIF(cur,file);
          break;
*/
        default:
          ret=false;
          break;
      }
      if (ret)
        alert(gStrings.getString('stored'));
      else
        alert(gStrings.getString('storefailed'));
    }
} //
function UploadMab()
{ //upload single mab from options menu
    var mabFile = document.getElementById( "MabList1" ).selectedItem.value;
    var mabName = document.getElementById( "MabList1" ).selectedItem.label;
    showPopup('upload', mabFile, false, false, true);
}

function LoadMab()
{
  var filename = document.getElementById( "MabFilePath" ).value;
  if (!filename) return;

  var mabName = document.getElementById( "MabName" ).value;
  if (!mabName) return;

  var mabFile='';
  var create;

  var cur=gAddressbooksSync.getAddressBook(mabName);
  if (cur) {
    var dirProp = gAddressbooksSync.noDirProp?cur:cur.directoryProperties;
    mabFile=dirProp.fileName;
    if (askOverwrite(cur, true)) return;
    create=false;
  } else {
    mabFile = mabName.replace( /\W/g, "_" )+'.mab'; //internal filename should not contain spaces
    create=true;
  }
  file = Components.classes["@mozilla.org/file/local;1"].
    createInstance(Components.interfaces.nsILocalFile);
  try{ file.initWithPath( filename ); }
  catch(e) {
    alert(gStrings.getString('nofile'));
    file=null;
  }
  if (file) {
    var ret;
    if ((ret=replaceAddressBook(mabName, mabFile, file))) {
      alert(gStrings.getString('notcopied')+' '+ret);
      file=null;
    }
  }
  if (file) {
    document.getElementById( "MabFilePath" ).value='';
    document.getElementById( "MabName" ).value='';
    if (create) abs_init(); // insert in options list
    else        refreshAddressbook();
    alert(gStrings.getString('loaded'));
  }
}
function DownloadMab()
{
  var mabName = document.getElementById( "DownloadMabName" ).value;
  if (!mabName) return;

  var mabFile='';

  var cur=gAddressbooksSync.getAddressBook(mabName);
  var create;
  if (cur) {
    var dirProp = gAddressbooksSync.noDirProp?cur:cur.directoryProperties;
    mabFile=dirProp.fileName;
    if (askOverwrite(cur, true)) return;
    create=false;
  } else {
dump('---downloading new!\n');
    mabFile = mabName;
    create=true;
  }

//  document.getElementById("UseMabFile").value=mabFile;
//  document.getElementById("MabCreated").setAttribute('checked', create);
  showPopup('download', mabFile, false, false, true);
//TODO: in download() sollte kein test auf file modification stattfinden

}

function get_password(protocol, host, user){
  if (Components.classes["@mozilla.org/login-manager;1"]) { // since TB3b2
    var hostname = protocol+'://'+host;
    var httprealm = 'AddressbooksSynchronizer';

    try {
      var loginManager = Components.classes["@mozilla.org/login-manager;1"]
         .getService(Components.interfaces.nsILoginManager);
      var logins = loginManager.findLogins({}, hostname, null, httprealm);
      for (var i = 0; i < logins.length; i++) {
        if (logins[i].username == user) {
          return logins[i].password;
        }
      }
      //try to find pre TB3b2 entry
      logins = loginManager.findLogins({}, host, host, null);
      for (var i = 0; i < logins.length; i++) {
        if (logins[i].username == user) {
          return logins[i].password;
        }
      }
    } catch(e) {dump(e+'\n'); }
  } else {
    var dhost= new Object();
    var duser= new Object();
    var pass= new Object();
    try {
      var pmInternal = Components.classes["@mozilla.org/passwordmanager;1"]
                      .createInstance(Components.interfaces.nsIPasswordManagerInternal);
      var ret=pmInternal.findPasswordEntry(host,user,"",dhost,duser,pass);
      return pass.value;
    } catch(e) {dump(e+'\n'); }
  }
  return "";
}

function set_password(protocol, host, user, pwd){
  if (Components.classes["@mozilla.org/login-manager;1"]) { // since TB3b2
    var hostname = protocol+'://'+host;
    var httprealm = 'AddressbooksSynchronizer';

    try {
      var loginManager = Components.classes["@mozilla.org/login-manager;1"]
         .getService(Components.interfaces.nsILoginManager);

      //find and remove pre TB3b2 entries
      var logins = loginManager.findLogins({}, host, host, null);
      for (var i = 0; i < logins.length; i++) {
        if (logins[i].username == user) {
          loginManager.removeLogin(logins[i]);
        }
      }
      logins = loginManager.findLogins({}, hostname, null, httprealm);
      for (var i = 0; i < logins.length; i++) {
        if (logins[i].username == user) {
          loginManager.removeLogin(logins[i]);
        }
      }
      var loginInfo = Components.classes["@mozilla.org/login-manager/loginInfo;1"]
                   .createInstance(Components.interfaces.nsILoginInfo);
      loginInfo.init(hostname, null, httprealm, user, pwd, "", "");
      loginManager.addLogin(loginInfo);
    }
    catch(e) { alert(e); dump(e)+'\n'; }
  } else {
    var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"]
            .createInstance(Components.interfaces.nsIPasswordManager);
    try {
      passwordManager.removeUser(host,user);
    } catch(e) { }
    passwordManager.addUser(host,user,pwd);
  }
}

function uploadNow(force)
{//called via button click, not via automatic upload at end
  abs_finish(); //ggf ge�nderte Parameter �bernehmen!
  if (gAddressbooksSync.synctype!='none')
    showPopup('upload', null, false, false, force);
}

function downloadNow(force)
{//called via button click, not via automatic download at start
  abs_finish(); //ggf ge�nderte Parameter �bernehmen!
  if (gAddressbooksSync.synctype!='none')
    showPopup('download', null, false, false, force);
}

function uploadThis()
{ //called via context menu
  if (gAddressbooksSync.synctype!='none') {
    var abDir=GetSelectedDirectory(); //the URI
    var dir = GetDirectoryFromURI(abDir);
    var dirProp = gAddressbooksSync.noDirProp?dir:dir.directoryProperties;
    showPopup('upload', dirProp.fileName, false, false, true);
//    else  // also checked via events.js
//alert('upload in progress');
  }
}

function downloadThis()
{ //called via context menu
  if (gAddressbooksSync.synctype!='none') {
    var abDir=GetSelectedDirectory(); //the URI
    var dir = GetDirectoryFromURI(abDir);
    var dirProp = gAddressbooksSync.noDirProp?dir:dir.directoryProperties;
    showPopup('download', dirProp.fileName, false, false, true);
//    else  // also checked via events.js
//alert('download in progress');

  }
}
